// -*-C++-*-
//
// File:      OmSource.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Sep 13 17:00:17 CEST 2002
// Usage:     -
// Info:      -

#ifndef OmSourceLabelEdit_h
#define OmSourceLabelEdit_h
#include <qwidget.h>
#include <qlineedit.h>
#include <qstring.h>
class OmSourceLabel;
class OmSourceEdit;
class QWidget;
class OmSourceLabelEdit : public QWidget
{
  //     Q_OBJECT  
public:
   OmSourceLabelEdit(QWidget *parent,
		   QString labelString,	     
		   QString editString, 
		   int xPos, int yPos, int height,  
                   QString help = QString::null); 
        
         

   virtual ~OmSourceLabelEdit() {};
   virtual void setText(const QString &);
private:
  
  OmSourceLabel * _label;   // The label will lie to the left of the edit box
  OmSourceEdit * _edit;     // To dispaly a number to the right of the label
  QString _labelName;    
  

};
#endif





