/****************************************************************************
** Form implementation generated from reading ui file 'testdialog.ui'
**
** Created: Mon Feb 24 14:33:07 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

// QT header files

#include <qapplication.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qcombobox.h>
#include <qwhatsthis.h>
#include <qinputdialog.h>
#include <qtimer.h>
#include <cmath>
#include <cstring>
#include <qstring.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qprinter.h> 
#include <qpainter.h>
#include <qfont.h> 
#include <qpaintdevicemetrics.h> 
#include <qdatetime.h>
#include <qmenubar.h>
#include <qmessagebox.h>
#include "Dal.h"
// omsource header files

#include "OmSourceLog.h"
#include "OmImageDisplay.h"
#include "OmSourceRegions.h"
#include "OmSourceVersionNo.h"
#include "OmProgressDialog.h"
#include "OmSourcePhotometryDlg.h"
#include "OmSourceNumerics.h"
#include "OmSourceProcessDlg.h"
#include "OmSourceInformationDlg.h"
#include "OmSourceBackgroundDlg.h"

//#include "OmSourceGraphDlg.h"
#include "OmSourceBrowser.h"
#include "OmSourceButton.h"
#include "OmSourceGroupBox.h"
#include "OmSourceLabel.h"
#include "OmSourceInformationMenu.h"
#include "OmSourceHelp.h" 
#include "OmSourceEdit.h"
#include "OmSourceRegions.h"
#include "OmSourceLabelEdit.h"
#include"OmSpinBox.h"


/* 
 *  Constructs a PhotometryDlg which is a child of 'parent', with the computeB  
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */

// FORTRAN prototypes
F90MODPROCPROTO(void,omsource_old, setesourcephotometrymethod)(const int16& method);

F90MODPROCPROTO(void,omsource_glue, recompute)(const int& id);
F90MODPROCPROTO(void, omsource_glue, replace)(const int &id, OmSourceParameter& source);
F90MODPROCPROTO(void, omsource_glue, getbackgroundregions)(OmSourceRegions *regions);
F90MODPROCPROTO(void, omsource_glue, getthecounts)(const float &radius);
F90MODPROCPROTO(void, omsource_glue, getsourcecounts)(const float &x, 
             const float &y, const float &radius, float &counts);
F90MODPROCPROTO(void, omsource_glue, getthebackgroundcounts)(const float &x, 
             const float &y, const float &radius, float &r1, float &r2, float &counts);
F90MODPROCPROTO(void, omsource_glue, computebackground)(float &counts, float &error);

F90MODPROCPROTO(float, omsource_glue, getthebackgroundmode)();




F90MODPROCPROTO(void,omsource_glue, deletebackgroundlist)();
F90MODPROCPROTO(void, omsource_glue, deletebackgroundregions)();




F90MODPROCPROTO(int8, omsource_glue, getsourceextensionflag)(int &);


  
extern F90MODVARDEF(OmSourceParameters, omsource_glue, mysources);
extern F90MODVARDEF(OmSourceParameters, omsource_glue, mybackgroundsources);
extern F90MODVARDEF(PhotometryParameters, omsource_glue, myphotometryparameters);


extern F90MODVARDEF(int, omsource_glue, myimagenx);
extern F90MODVARDEF(int, omsource_glue, myimageny);








string PhotometryDlg::_colour1 = "blue", PhotometryDlg::_colour2 = "cyan";
int PhotometryDlg::_colour1No = 4, PhotometryDlg::_colour2No = 5;



 
/***************************************
*
* Constructor
*
***************************************/
PhotometryDlg::PhotometryDlg(const int no, 
			OmImageDisplay *displayIn, 
                        const OmSourceBrowser::ObsDetails* obsDetails,
                        const OmSourceBrowser::ImageDetails* imageDetails,
			const string oldRegionsColour, 
			     vector<string> colourList,
                        QWidget* parent,  
                        const char* name, 
                        bool modal, 
                        WFlags fl)
  : QDialog( parent, name, modal, fl ), 
  _sourceNo(no), _display(displayIn),  _obsDetails(obsDetails),  
  _imageDetails(imageDetails), _zoomFactor(6), _displayUpdated(false),  // was 5
    _fixedBackground(false), _oldRegionsColour(oldRegionsColour),
    _colourList( colourList )




{

    // Need the image dimensions to stop the user selecting sources outside the image
    _nx = (float)(F90MODPROC( omsource_glue, myimagenx ) + 1);
    _ny = (float)(F90MODPROC( omsource_glue, myimageny ) + 1);

    
    /****************************************************************
    * Initialise the extended-source photometry method to -1 
    * (background from annulus)
    ********************************************************************/
    _extendedSourcePhotometryMethod = -1;



    if( _obsDetails->filter == "UVW1" || _obsDetails->filter == "UVW2" ||  _obsDetails->filter == "UVM2")
    {
        _isUVFilter = true;
    }
    else
    {
        _isUVFilter = false;
  

    }

    _timer = 0;
    //  QToolTip::add(this, "This is a test");
    string text2 = "Constructing photometry window- please wait";
   
    OmProgressDialog *reporter = new OmProgressDialog(text2, 41);
    
    reporter->setProgress(1);
   
     // load display
    _display = new OmImageDisplay;
     
    reporter->setProgress(2);
  
    _background = -1.0;
    

    if ( !name )
	setName( "Photometry" );
    //resize( 580, 950 ); 
    resize( 750, 950 ); 
  
    QString text;
    text.sprintf("Imaging photometry (Source no %d, Filter=%s, exposure=%6d seconds)", no,  
      (const char*)_obsDetails->filter,  (int)_obsDetails->exposure);

    setCaption( tr( text) );

    int height = 25;
    int yPos = 25;

    /*******************************************************
    * Raw count rates
    ******************************************************/
    _rawRateGroupBox = new OmSourceGroupBox( this,  "Raw count rates (counts/sec)",  10, yPos, 230, 140,
          "The following rates are those obtained from the source photometry\n"
	  "before any corrections have been made");

    //    QToolTip::add(_rawRateGroupBox, "The following rates are those obtained from the source photometry\n"
    //	  "before any corrections have been made");


    reporter->setProgress(2);

  
    // Total
    int xPos = 130;
    xPos = 10;
    int pmSpacing = 2;
  

    _rawTotalRateTxt = new OmSourceLabel(_rawRateGroupBox, "Total", xPos, yPos, height,
         "(Backgound counts + source counts) / exposure (counts/sec)");
  
 
    xPos += 90;
    _rawTotalRateEdt = new OmSourceEdit(   _rawRateGroupBox, "400.0", xPos, yPos, 50, height); 
    reporter->setProgress(3);
   
  
    xPos = _rawTotalRateEdt->x() +  _rawTotalRateEdt->width() + pmSpacing;
 
    _rawTotalRateErrTxt = new OmSourceLabel(_rawRateGroupBox,  tr( "+/-" ),  xPos, yPos, height,
       "The error in the total rate (counts/sec)" );
    reporter->setProgress(4);
   
 
    xPos = _rawTotalRateErrTxt->x() +  _rawTotalRateErrTxt->width() + pmSpacing;
 
    _rawTotalRateErrEdt = new OmSourceEdit(   _rawRateGroupBox, "400.0", xPos, yPos, 40, height  ); 
   
  
    // Background
    xPos = 10;
    yPos += 40;
    _rawBackgroundRateTxt = new OmSourceLabel(_rawRateGroupBox, "Background", xPos, yPos, height,
       "Backgound counts / exposure (counts/sec)");
    
   
    xPos += 90;
    _rawBackgroundRateEdt = new OmSourceEdit(   _rawRateGroupBox, "0.00", xPos, yPos, 50, height ); 
    reporter->setProgress(5);
   

 
    xPos = _rawBackgroundRateEdt->x() +  _rawBackgroundRateEdt->width() + pmSpacing;
 
    _rawBackgroundRateErrTxt = new OmSourceLabel(_rawRateGroupBox, tr( "+/-" ),  xPos, yPos, height);
    reporter->setProgress(7);
   
 
    xPos = _rawBackgroundRateErrTxt->x() +  _rawBackgroundRateErrTxt->width() + pmSpacing;
 
    _rawBackgroundRateErrEdt = new OmSourceEdit( _rawRateGroupBox, "100.0", xPos, yPos, 40, height ); 
  
 
    // Background subtracted

    xPos = 10;
    yPos += 40;
    _rawBackgroundSubtractedRateTxt = new OmSourceLabel(_rawRateGroupBox, "Source",  xPos, yPos, height,
                "Backgound-subtracted counts / exposure (counts/sec)");
      
    xPos += 90;
    _rawBackgroundSubtractedRateEdt = new OmSourceEdit(   _rawRateGroupBox, "4000.0", xPos, yPos, 50, height  ); 
    reporter->setProgress(6);
   

  


    xPos = _rawBackgroundSubtractedRateEdt->x() +  _rawBackgroundSubtractedRateEdt->width() + pmSpacing;
 
    _rawBackgroundSubtractedRateErrTxt = new OmSourceLabel(_rawRateGroupBox, tr( "+/-" ),  xPos, yPos, height);
    reporter->setProgress(7);
   
 
    xPos = _rawBackgroundSubtractedRateErrTxt->x() +  _rawBackgroundSubtractedRateErrTxt->width() + pmSpacing;
 
    _rawBackgroundSubtractedRateErrEdt = new OmSourceEdit( _rawRateGroupBox, "100.0", xPos, yPos, 40, height ); 
  
    reporter->setProgress(8);
   

    /****************************************************************************
     * Corrected count rates
     ***************************************************************************/
    yPos = _rawRateGroupBox->geometry().top();

    _corrRateGroupBox = new OmSourceGroupBox( this,  "Corrected count rates (counts/sec)", 
					      //280, yPos, 230, 140,
					      280, yPos-2, 240, 155,
         "The following rates are those obtained from the source photometry\n"
	  "after the listed corrections have been made");
    //    QToolTip::add(_corrRateGroupBox, "The following rates are those obtained from the source photometry\n"
    //	  "after the listed corrections have been made");
 
    

    // Total
    xPos = 10;
    yPos = 20;
    _corrTotalRateTxt = new OmSourceLabel(_corrRateGroupBox, "Total", xPos, yPos, height,
          "CL-corrected total (backgound + source) count rate; scaled \n to the photometry aperture area which has the 35-pixel radius for the UV filters \n and 12-pixel radius for the visible ones");
    
 
    xPos += 90;
    _corrTotalRateEdt = new OmSourceEdit(   _corrRateGroupBox, "400.0", xPos, yPos, 50, height ); 
    reporter->setProgress(9);
   
  
    xPos = _corrTotalRateEdt->x() +  _corrTotalRateEdt->width() + pmSpacing;
 
    _corrTotalRateErrTxt = new OmSourceLabel(_corrRateGroupBox,  tr( "+/-" ),  xPos, yPos, height,
      "The error in the corrected total rate (counts/sec)" );
  
    reporter->setProgress(10);
   
 
    xPos = _corrTotalRateErrTxt->x() +  _corrTotalRateErrTxt->width() + pmSpacing;
 
    _corrTotalRateErrEdt = new OmSourceEdit(   _corrRateGroupBox, "400.0", xPos, yPos, 40, height  ); 
    reporter->setProgress(11);

  

   
    /*******************************************  
    * Background
    *******************************************/
    xPos = 10;
    yPos += 40;
    _corrBackgroundRateTxt = new OmSourceLabel(_corrRateGroupBox, "Background", xPos, yPos, height,
         "CL-corrected backgound count rate; scaled to the photometry aperture area \n which has the 35-pixel radius for the UV filters and 12-pixel radius for the visible filters");
    

    xPos += 90;
    _corrBackgroundRateEdt = new OmSourceEdit(_corrRateGroupBox, "4000.0", xPos, yPos, 50, height ); 
    reporter->setProgress(12);
   
    xPos = _corrBackgroundRateEdt->x() +  _corrBackgroundRateEdt->width() + pmSpacing; 
    _corrBackgroundRateErrTxt = new OmSourceLabel(_corrRateGroupBox, tr( "+/-" ),  xPos, yPos, height);
   
    xPos = _corrBackgroundRateErrTxt->x() +  _corrBackgroundRateErrTxt->width() + pmSpacing;
    _corrBackgroundRateErrEdt = new OmSourceEdit( _corrRateGroupBox, "100.0", xPos, yPos, 40, height ); 
  
  
 
    /****************************************
    * Background subtracted
    *****************************************/
    xPos = 10;
    yPos += 40;
    _corrBackgroundSubtractedRateTxt = new OmSourceLabel(_corrRateGroupBox, "Source",  xPos, yPos, height,
	    //"The corrected background-subtracted counts / exposure (counst/sec)");
	   "The CL-corrected and background-subtracted sorce count rate; scaled to the photometry area \n which has the 35-pixel radius for the UV filters and 12-pixel radius for the visible filters");
  
 
    xPos += 90;
    _corrBackgroundSubtractedRateEdt = new OmSourceEdit(   _corrRateGroupBox, "4000.0", xPos, yPos, 50, height  ); 
    reporter->setProgress(13);
    
  
    xPos = _corrBackgroundSubtractedRateEdt->x() +  _corrBackgroundSubtractedRateEdt->width() + pmSpacing;
 
    _corrBackgroundSubtractedRateErrTxt = new OmSourceLabel(_corrRateGroupBox, tr( "+/-" ),  xPos, yPos, height,
	    "The error in the corrected background-subtracted count-rate (counts/sec)");
   
    reporter->setProgress(14);
   
    xPos = _corrBackgroundSubtractedRateErrTxt->x() +  _corrBackgroundSubtractedRateErrTxt->width() + pmSpacing;
 
    _corrBackgroundSubtractedRateErrEdt = new OmSourceEdit(   _corrRateGroupBox, "100.0", xPos, yPos, 40, height ); 
    reporter->setProgress(15);
   
 
    /****************************************
    * Label for the photometry aperture
    *****************************************/
    xPos = 14;
    yPos += 30;

    auxLabel1 = new OmSourceLabel(_corrRateGroupBox, "(scaled to the CAL photometry region)",  
				xPos, yPos, 220, 18, QColor(230, 230, 230),
	   "The CAL photometry region has radius 35 pixels for the UV filters \n and 12-pixels for the visible filters");

    //Qlabel* pLabel1 = new QLabel;
    //pLabel1





    /********************************************************
     * Corrections applied
     *******************************************************/
        
    _correctionsGroupBox = new OmSourceGroupBox( this,  "Corrections applied",  10, 170, 190, 500,
	  "The corrections that have been applied in converting from raw to corrected count-rates (listed in order)");

    //    QToolTip::add(_correctionsGroupBox,  "The corrections that have been applied in converting from raw to corrected rates");

    int maxWidth = 0; 

    xPos = 10;
    yPos = 20;
 
    _psf1CorrectionTxt = new OmSourceLabel(_correctionsGroupBox, "PSF1",  xPos, yPos, height,
      "The correction (expressed as a ratio) applied to extrapolate,\n"
      "using the point-spread function, the raw counts measured within the\n"
      "aperture radius to that within the coincidence-loss radius");
    QToolTip::add(_psf1CorrectionTxt, "The correction (expressed as a ratio) applied to extrapolate,\n"
      "using the point-spread function, the raw background-subtracted count rate  measured within the\n"
      "aperture radius to that within the coincidence-loss radius\n"
      "Please note that the raw-background count rate is extrapolated to the coincidence-loss\n"
		  "ratio by the multiplication factor (coincidence-loss radius / aperture radius)**2");

    maxWidth = max(maxWidth, _psf1CorrectionTxt->geometry().right() );



    // Total
    int dy = 35;


    yPos += dy;
     _coincCorrectionTxt1 = new OmSourceLabel(_correctionsGroupBox,  tr( "B Coinc-loss"), xPos, yPos, height,
	   "The correction applied (expressed as a ratio) to correct the background count-rate for coincidence-losses\n"
	  "PLEASE NOTE THAT THIS ALSO INCLUDES the DEAD-TIME CORRECTION");
  
    QToolTip::add(_coincCorrectionTxt1,  
          "The correction applied (expressed as a ratio) to correct the background count-rate for coincidence-losses\n"
	  "PLEASE NOTE THAT THIS ALSO INCLUDES the DEAD-TIME CORRECTION");

    maxWidth = max(maxWidth, _coincCorrectionTxt1->geometry().right() );

 

    xPos = 10;
    yPos += dy;
    _coincCorrectionTxt2 = new OmSourceLabel(_correctionsGroupBox,  tr( "S+B Coinc-loss"), xPos, yPos, height,
	   "The correction applied (expressed as a ratio) to correct the source+background count-rate for coincidence-losses\n"
	   "PLEASE NOTE THAT THIS ALSO INCLUDES the DEAD-TIME CORRECTION");

     QToolTip::add(_coincCorrectionTxt2,  
          "The correction applied (expressed as a ratio) to correct the source+background count-rate  for coincidence-losses\n"
  	  "PLEASE NOTE THAT THIS ALSO INCLUDES the DEAD-TIME CORRECTION");

    maxWidth = max(maxWidth, _coincCorrectionTxt2->geometry().right() );


    reporter->setProgress(16);
     
  
    xPos = 10;
    yPos += dy;
    _psf2CorrectionTxt = new OmSourceLabel(_correctionsGroupBox, "PSF2",  xPos, yPos, height,
            "A correction (expressed as a percentage), only applicable to UV data,\n"
            " to extrapolate, using the point-spread function, the counts to the\n"
            "area of the UV point-spread function"); 
    QToolTip::add(_psf2CorrectionTxt,    "A correction (expressed as a ratio),\n"
         " to extrapolate, using the point-spread function, the counts to the\n"
         "area of the UV point-spread function\n"
		  "NB This is only applicable to UV data"); 

    maxWidth = max(maxWidth, _psf2CorrectionTxt->geometry().right() );

    reporter->setProgress(17);
   
    xPos = 10;
    yPos += dy;
    _tdsCorrectionTxt = new OmSourceLabel(_correctionsGroupBox, "TDS corr", xPos, yPos, height,
              "The time-dependent sensitivity correction applied");
    QToolTip::add(_tdsCorrectionTxt, "The time-dependent sensitivity correction applied");
 

    maxWidth = max(maxWidth, _tdsCorrectionTxt->geometry().right() );


    //********************************************************
    // The edit boxes to display the actual values
    //********************************************************

    xPos = maxWidth + 20;
    maxWidth = 0;

    yPos = _psf1CorrectionTxt->geometry().top();


    _psf1CorrectionEdt = new OmSourceEdit(   _correctionsGroupBox, "1.000", xPos, yPos, 50, height ); 
   

    QToolTip::add(_psf1CorrectionEdt, "The correction (expressed as a ratio) applied to extrapolate,\n"
      "using the point-spread function, the raw background-subtracted count rate  measured within the\n"
      "aperture radius to that within the coincidence-loss radius\n"
      "Please note that the raw-background count rate is extrapolated to the coincidence-loss\n"
		  "ratio by the multiplication factor (coincidence-loss radius / aperture radius)**2");

    maxWidth = max(maxWidth, _psf1CorrectionEdt->geometry().right());


   yPos += dy;

   _coincCorrectionEdt1 = new OmSourceEdit(   _correctionsGroupBox, "4000.0", xPos, yPos, 50, height  ); 
     
    QToolTip::add(_coincCorrectionEdt1,  
          "The correction applied (expressed as a ratio) to correct the background count-rate for coincidence-losses\n"
	  "PLEASE NOTE THAT THIS ALSO INCLUDES the DEAD-TIME CORRECTION");

    yPos += dy;

   _coincCorrectionEdt2 = new OmSourceEdit(   _correctionsGroupBox, "4000.0", xPos, yPos, 50, height  ); 
   
     QToolTip::add(_coincCorrectionEdt2,  
          "The correction applied (expressed as a ratio) to correct the source+background count-rate  for coincidence-losses\n"
  	  "PLEASE NOTE THAT THIS ALSO INCLUDES the DEAD-TIME CORRECTION");

    maxWidth = max(maxWidth, _coincCorrectionEdt2->geometry().right());

    yPos += dy;
    _psf2CorrectionEdt = new OmSourceEdit(   _correctionsGroupBox, "1.000", xPos, yPos, 50, height ); 
    QToolTip::add(_psf2CorrectionEdt,    "A correction (expressed as a ratio) to extrapolate,\n"
          "using the point-spread function, the background-subtracted count-rate to the area of the UV point-spread function\n"
		  "NB This is only applicable to UV data");

          
    maxWidth = max(maxWidth, _psf2CorrectionEdt->geometry().right());

    yPos += dy;

    _tdsCorrectionEdt = new OmSourceEdit(  _correctionsGroupBox, "0.23478", xPos, yPos, 50, height );
    QToolTip::add(_tdsCorrectionEdt, "The time-dependent sensitivity correction applied");
   
    maxWidth = max(maxWidth, _tdsCorrectionEdt->geometry().right());


    _correctionsGroupBox->resize( maxWidth + 10, _tdsCorrectionEdt->geometry().bottom() + 20);


    reporter->setProgress(18);
   
  
    /*************************************************
     * Instrumental magnitudes, AB mags and fluxes
     ************************************************/
     yPos = _corrRateGroupBox->geometry().bottom() + 10;
    _magnitudeGroupBox = new OmSourceGroupBox( this,  "Instrumental magnitude/flux",  280, yPos-3, 230, 150,
			 "The magnitude obtained from the corrected count-rate");
   
    //    QToolTip::add(_magnitudeGroupBox, "The following have been computed using the corrected count-rates");


    xPos = 10;
    yPos = 20;
    _magnitudeTxt = new OmSourceLabel(_magnitudeGroupBox, "Magnitude",  xPos, yPos, height);
    QToolTip::add(_magnitudeTxt, "The instrumental magnitude");

 
    xPos += 90;
    _magnitudeEdt = new OmSourceEdit(   _magnitudeGroupBox, "40.9", xPos, yPos, 50, height); 
    QToolTip::add(_magnitudeEdt, "The instrumental magnitude");

    reporter->setProgress(19);
   
 
    xPos = _magnitudeEdt->x() +  _magnitudeEdt->width() + pmSpacing;
 
    _magnitudeErrTxt = new OmSourceLabel(_magnitudeGroupBox,  tr( "+/-" ),  xPos, yPos, height,
       "The error in the instrumental magnitude");
 
    xPos = _magnitudeErrTxt->x() +  _magnitudeErrTxt->width() + pmSpacing;
   
    _magnitudeErrEdt = new OmSourceEdit(   _magnitudeGroupBox, "0.13", xPos, yPos, 40, height); 
    reporter->setProgress(20);
   
 
    xPos = 10;
    yPos += 40;
    _signalToNoiseTxt = new OmSourceLabel(_magnitudeGroupBox, "Signal/noise",  xPos, yPos, height,
           "The ratio source counts / sqrt(source+background counts)\n"
	   "For point-sources this is computed using a 3 arcsec aperture");
    
 

    xPos += 90;
    _signalToNoiseEdt = new OmSourceEdit(   _magnitudeGroupBox, "5000.0", xPos, yPos, 50, height,
           "The ratio source counts / sqrt(source+background counts)\n" 
	   "For point-sources this is computed using a 3 arcsec aperture");
    


    /*****************************************************************************************
    * AB Magnitudes
    *****************************************************************************************/


    xPos = 10;
    yPos += 40;
    _ABMagnitudeTxt = new OmSourceLabel(_magnitudeGroupBox, "AB Magnitude",  xPos, yPos, height);
    QToolTip::add(_ABMagnitudeTxt, "The AB magnitude");

 
    xPos += 90;
    _ABMagnitudeEdt = new OmSourceEdit(   _magnitudeGroupBox, "40.9", xPos, yPos, 50, height); 
    QToolTip::add(_magnitudeEdt, "The AB magnitude");

    reporter->setProgress(19);
   
 
    xPos = _ABMagnitudeEdt->x() +  _ABMagnitudeEdt->width() + pmSpacing;
 
    _ABMagnitudeErrTxt = new OmSourceLabel(_magnitudeGroupBox,  tr( "+/-" ),  xPos, yPos, height,
       "The error in the AB magnitude");

 
    xPos = _ABMagnitudeErrTxt->x() +  _ABMagnitudeErrTxt->width() + pmSpacing;
   
    _ABMagnitudeErrEdt = new OmSourceEdit(   _magnitudeGroupBox, "0.13", xPos, yPos, 40, height); 
    reporter->setProgress(20);
   
 
    /*****************************************************************************************
    * AB Fluxes
    *****************************************************************************************/
    xPos = 10;
    yPos += 40;
    _ABFluxTxt = new OmSourceLabel(_magnitudeGroupBox, "AB Flux Density",  xPos, yPos, height);
    QToolTip::add(_ABMagnitudeTxt, "The AB flux");

 
    xPos = _ABMagnitudeTxt->geometry().right() + 20;
    _ABFluxEdt = new OmSourceEdit(   _magnitudeGroupBox, "0.000000000000001", xPos, yPos, 50, height); 
    QToolTip::add(_ABFluxEdt, "The AB flux density (ergs/cm**2/sec/A)");


    yPos = _ABFluxEdt->geometry().bottom();
    xPos = 10;
 
    _ABFluxErrTxt = new OmSourceLabel(_magnitudeGroupBox,  tr( "+/-" ),  xPos, yPos, height,
       "The error in the AB flux density (ergs/cm**2/sec/A)");

    
    xPos = _ABFluxEdt->geometry().left();
    _ABFluxErrEdt = new OmSourceEdit(   _magnitudeGroupBox, "0.000000000001", xPos, yPos, 50, height); 
    reporter->setProgress(20);
   
    _magnitudeGroupBox->resize( _magnitudeGroupBox->width(), _ABFluxErrEdt->geometry().bottom() + 10);


    reporter->setProgress(21);
   
 
     /***********************************************************
     * Source type
     **********************************************************/ 
    xPos = 10;
    yPos = _correctionsGroupBox->geometry().bottom() + 10;
 

    // Create a button group to contain all buttons
    QButtonGroup *sgroup = new QButtonGroup( this, "Source type" );
    sgroup->setTitle("Source type");
    sgroup->setGeometry(xPos, yPos, 200, 200);
    sgroup->resize( 200, 200 );
    connect( sgroup, SIGNAL(clicked(int)), SLOT(sourceTypeHasChanged(int)) );


    // Calculate the size for the radio buttons
    int maxwidth = 80;
    int maxheight = 10;

    const char *n;
    QFontMetrics fm = sgroup->fontMetrics();


    // Find out the longest function description.
    // Here we make use of the last "0,0"-entry in the
    // ourDrawFunctions-array.
    QString sButtonName[3];
    sButtonName[0] = "Point";
    sButtonName[1] = "Extended";
    sButtonName[2] = QString::null;
    QString sToolTipName[2];
    sToolTipName[0] =  "The source will be assumed to be a point-source.\n"
                       "The photometry will be conducted using a circular aperture.\n"
                       "The background will be either obtained from the pixels within the\n"
                       "background annulus, from user-selected regions or from a user fixed\n"
                       "background value, depending on which button in the backround determination\n"
                       "box is set.";  
    sToolTipName[1] =  "The source will be assumed to be an extended-source.\n"
                       "The photometry will be conducted using an elliptical aperture.\n"
                       "The background will be subtracted using either the pixels within the\n"
                       "background elliptical annulus, from a user fixed backgrpund value or\n"
                       "by using the pixels within the background annulus to interpolate the\n"
                       "background to the source region, depending on which button in the\n"
                       "backround determination box is set.";  
       

    for (int i=0; (n=sButtonName[i]) != 0; i++ ) {
        int w = fm.width( n );
        maxwidth = QMAX(w,maxwidth); // QMAX is a macro defined in qglobal.h
                                     // and returns the biggest of to values.
        // Due to its macro nature one should use it with care and with
        // constant parameters only.
    }
 

    maxwidth = maxwidth + 20;                   // allow 30 pixels for radiobuttons
    int y0 = 20;
    for (int i=0; (n = sButtonName[i]) != 0; i++ ) {
        _sourceTypeRadioBtn[i] = new QRadioButton( n, sgroup );
        _sourceTypeRadioBtn[i]->setGeometry( 10, y0, maxwidth, 30 );
        y0 += 30;
	QToolTip::add( _sourceTypeRadioBtn[i] , (const char *)sToolTipName[i]);
      
    
        maxheight += 30;

    }

    sgroup->resize( maxwidth + 20, maxheight + 20);

    reporter->setProgress(22);
   
   
    /***********************************************************
    * Background  determination
    **********************************************************/
    xPos = sgroup->geometry().right()  + 20;
    yPos =  sgroup->geometry().top();

    // Create a button group to contain all buttons
    QButtonGroup *bgroup = new QButtonGroup( this, "Background determination" );
    bgroup->setTitle("Background determination");
    bgroup->setGeometry(xPos, yPos, 200, 200);
    bgroup->resize( 200, 200 );
    connect( bgroup, SIGNAL(clicked(int)), SLOT(updateBackgroundDetermination(int)) );

    // Calculate the size for the radio buttons
    maxwidth = 80;
    maxheight = 10;
    

    fm = bgroup->fontMetrics();

    // Find out the longest function description.
    // Here we make use of the last "0,0"-entry in the
    // ourDrawFunctions-array.
    //QString buttonName[4];
    std::vector<QString> buttonName;
    buttonName.push_back("Annulus");
    buttonName.push_back("User regions");
    buttonName.push_back("User value");
    buttonName.push_back( "Interpolate");

    QString toolTipName[4];
    toolTipName[0] =  "The background will be subtracted by using the pixels within\n"
      "the background annulus to determine the background mode.\n";
    
    toolTipName[1] = "Uses the background regions selected on the image\n"
                     "to determine the background.\n"
                     "A region is selected by positioning the cursor\n"
                     "at the selected point and clicking the\n"
                     "left-mouse button. Each region\n"
                     "is circular with a diameter equal\n"
                     "to the aperture diameter";
    toolTipName[2] = "Uses your background value (counts/pixel)";
    toolTipName[3] = "The background will be subtracted by using the pixels\n"
                     "within the background annulus to interpolate the background\n"
                     "to the source region (only when the extended source-type button is set).";
 

    for (unsigned int i=0; i < buttonName.size(); i++ ) {
      n=buttonName[i]; 
      int w = fm.width( n );
      maxwidth = QMAX(w,maxwidth); // QMAX is a macro defined in qglobal.h
      // and returns the biggest of to values.
      // Due to its macro nature one should use it with care and with
      // constant parameters only.
    }

 
    maxwidth = maxwidth + 20;                   // allow 30 pixels for radiobuttons
    y0 = 20;
    for (unsigned int i=0; i < buttonName.size() ; i++ ) {
      n = buttonName[i];
      _backgroundRadioBtn[i] = new QRadioButton( n, bgroup );
      _backgroundRadioBtn[i]->setGeometry( 10, y0, maxwidth, 30 );
      y0 += 30;
      QToolTip::add( _backgroundRadioBtn[i] , (const char *)toolTipName[i]);
      
    
      maxheight += 30;
    }

    _backgroundRadioBtn[0]->setChecked( TRUE );
    reporter->setProgress(22);
   
    xPos = maxwidth + 5;                                            ;
    yPos = 50;                           ;
   
  
    _backgroundBtn = new OmSourceButton( bgroup, "Select ", 
         xPos, yPos, 30,
         "Click here to show the background regions\n"
         "and select new ones");
 

    _backgroundBtn->setDisabled(true);
    connect(_backgroundBtn, SIGNAL(clicked()), this, SLOT(showBackgroundDlg()));
    

    n = bgroup->title();
    int w = fm.width( n );
    maxwidth = QMAX(w,maxwidth); 

    maxheight += 20;                            // maxheight is now 10 pixels upper margin
                                                // plus number_of_drawfunctions * 30
                                                // plus 10 pixels lower margin   

    maxwidth += 20;                             // add some margin, this results in the
                                                // final width of bgroup

    bgroup->resize( maxwidth, maxheight );      // resize bgroup to its final size
                                                // when no printersupport is provided
 
    /***********************************************************
     * Annuli
     **********************************************************/
    xPos = bgroup->geometry().right() + 20;;
    yPos = sgroup->geometry().top();
   
    xPos = bgroup->geometry().right() + 20;
  
    _annuliGroupBox = new OmSourceGroupBox( this,  "Annuli (pixels)", xPos, yPos, 160, 225);
    //    QToolTip::add(_annuliGroupBox, "The following controls allow you to change the aperture\n"
    //                                   "and the radii of the inner and outer background radii\n"
    //                                   "If the source is being treated as extended then you\n"
    //		                   "can also use an elliptical aperture");   

    reporter->setProgress(23);
   
    xPos = 10;
    yPos = 20;
   
    _apertureTxt = new OmSourceLabel(_annuliGroupBox, "Aperture",  xPos, yPos, height);


    /*****************************************************************************
    * Need the cal aperture radius (binned) for doing photometry
    ***************************************************************************/
    PhotometryParameters photParameters = F90MODVAR(omsource_glue, myphotometryparameters);
    _calApertureRadius =  photParameters.calApertureRadius; 
    _apertureRadius =  photParameters.apertureRadius;
    _zoomFactor = 3 * photParameters.binX;

    QTextOStream( &text ) << "The aperture radius (allowed values=" << int(_apertureRadius / 2.0 + 0.1)
                          << " - " 
                          << int(_apertureRadius + 0.1) << endl; 
                         

    QToolTip::add( _apertureTxt, text);
  
 
    xPos += 80; 
    _apertureSpinBox = new QSpinBox(   _annuliGroupBox, "SpinBox2" );
    _apertureSpinBox->setGeometry( xPos, yPos, 50, height ); 

    connect(_apertureSpinBox, SIGNAL(valueChanged(int)), this, SLOT(  apertureRadiusHasChanged(int)));
   
    QToolTip::add( _apertureSpinBox, text);
   

    xPos = 10;
    yPos += 30;
    _innerBckTxt = new OmSourceLabel(_annuliGroupBox,  tr( "Inner bck"),  xPos, yPos, height);
  
  
    xPos += 80;

 
    //   _innerBckRadius = int(_apertureRadius + 2.1);
    //   _outerBckRadius =  int( _innerBckRadius + 2.1);
     

    _innerBckSpinBox = new QSpinBox(   _annuliGroupBox, "SpinBox2" );
    _innerBckSpinBox->setGeometry( xPos, yPos, 50, height ); 
    reporter->setProgress(24);
   
    connect(_innerBckSpinBox,  SIGNAL(valueChanged(int)), 
           this, SLOT(  innerAnnulusRadiusHasChanged(int)));
    text = "";
    if (_calApertureRadius > 12)   	
        QTextOStream( &text) << "Change the background inner annulus radius\n"
			     << "allowed values=aperture radius + 2 - aperture radius + 32 pixels\n"
                            
                             << "Note that the point-spread function\n"
			     << "extends to " <<   _calApertureRadius << " pixels";
       
    else
        QTextOStream( &text) << "Change the background inner annulus radius\n"
                           << "allowed values=aperture radius + 2 - aperture radius + 32 pixels\n"
                           << "Note that the point-spread function\n"
			   << "extends to " <<   _apertureRadius << " pixels";


       
       
    QToolTip::add(_innerBckSpinBox, text);
    QToolTip::add(_innerBckTxt, text);

 
    xPos = 10;
    yPos += 30;
 
    _outerBckTxt = new OmSourceLabel(_annuliGroupBox,  tr( "Outer bck"),  xPos, yPos, height);
    reporter->setProgress(25);
   

    xPos += 80;
    _outerBckSpinBox = new QSpinBox( _annuliGroupBox, "SpinBox2" );
    _outerBckSpinBox->setGeometry( xPos, yPos, 50, height ); 

    QToolTip::add( _outerBckSpinBox ,
                  "Background outer annulus radius\n"
                  "(allowed values=inner background radius + 2 - inner background radius + 32 pixels)");
  
    QToolTip::add( _outerBckTxt ,
                  "Background outer annulus radius\n"
                  "(allowed values=inner background radius + 2 - inner background radius + 32 pixels)");
  

    connect( _outerBckSpinBox, SIGNAL(valueChanged(int)), 
           this, SLOT(  outerAnnulusRadiusHasChanged(int)));
	
 
    xPos = 10;
    yPos += 30;

 
    // Get the required source 
    OmSourceParameters& mySources = F90MODVAR( omsource_glue, mysources );   
 
    _originalSource = mySources[_sourceNo];
    _source = mySources[_sourceNo];


    _innerBckRadius = int (_originalSource.innerbackgroundradius + 0.1);
    _outerBckRadius = int(_originalSource.outerbackgroundradius + 0.1);
 
    
    //cout << "L980 innerbckradius=" <<    _innerBckRadius << endl;

    //cout << "L982 outerbckradius=" <<    _outerBckRadius << endl;

    //cout << "L984 originalsource photometry radius=" << _originalSource.photometryradius << endl;


    //cout << "L987 omsourcephotometrydlg original source inner bck=" << _originalSource.innerbackgroundradius << endl;
    //cout << "L988 omsourcephotometrydlg original source outer bck=" << _originalSource.outerbackgroundradius << endl;

    /************************************************************************************
    *
    *
    *************************************************************************************/
    _originalSource.extensionflag = F90MODPROC(omsource_glue, getsourceextensionflag)( _sourceNo );
 
    if(_originalSource.extensionflag == 1)
    {
        _originalSource.alpha = _originalSource.theta;  
        _originalSource.innerbackgroundradius = _innerBckRadius;
        _originalSource.outerbackgroundradius = _outerBckRadius;
        _originalSource.axialRatio = _originalSource.semia / _originalSource.semib;
        _source.alpha =  _originalSource.theta;
        _source.axialRatio = _originalSource.semia / _originalSource.semib;    
        _source.iMin = 0;        
        _isPointSource = false;;
        _isExtendedSource = true;


    }
    else
    {
        _source.iMin = -1;      
        _source.alpha = 0.0; 
        _source.axialRatio = 1.0; 
        _backgroundRadioBtn[3]->setDisabled( true );
        _isPointSource = true;
        _isExtendedSource = false;

    
    }
   
    F90MODPROC(omsource_glue, replace)(_sourceNo, _originalSource);  

    _axialRatioTxt = new OmSourceLabel(_annuliGroupBox,  tr( "a/b" ),  
        xPos, yPos, height,
        "Ellipse axial ratio, a/b (1 - 5)" );
    _axialRatioTxt -> setDisabled(true);
 
    xPos += 80;
      
   _axialRatioSpinBox = new OmSpinBox2( _annuliGroupBox, "SpinBox2", 1.0, 5.0, 0.05, _source.axialRatio, 0 ); 
   _axialRatioSpinBox->setGeometry( xPos, yPos, 50, height );    
    _axialRatioSpinBox->setDisabled(true);
    reporter->setProgress(26);
    QToolTip::add( _axialRatioSpinBox ,
                  "Ellipse axial ratio, a/b (1 - 5)");
  
    connect( _axialRatioSpinBox, SIGNAL(valueChanged(const QString &)), 
               this, SLOT(  axialRatioHasChanged( const QString &)));
	
   
    xPos = 10;
    yPos += 30;  
    _positionAngleTxt = new OmSourceLabel(_annuliGroupBox,  tr( "Pos angle"), xPos, yPos, height,
        "Angle (degrees) between the x-axis and the semi-major axis of the ellipse, measured anti-clockwise");
    _positionAngleTxt -> setDisabled(true);
 
    reporter->setProgress(27);
   
    xPos += 80;
    _positionAngleSpinBox = new QSpinBox(   _annuliGroupBox, "SpinBox2" );
    _positionAngleSpinBox->setGeometry( xPos, yPos, 50, height ); 
    _positionAngleSpinBox->setMinValue(0);
    _positionAngleSpinBox->setMaxValue(180);
    _positionAngleSpinBox->setLineStep(5);


    _positionAngleSpinBox->setValue(0);
    _positionAngleSpinBox -> setDisabled(true);
 

    QToolTip::add( _positionAngleSpinBox,
                  "Position Angle (0-180 degrees)");
  
    connect( _positionAngleSpinBox, SIGNAL(valueChanged(int)), 
           this, SLOT(  positionAngleHasChanged(int)));
	

    _annuliGroupBox->resize(_positionAngleSpinBox->geometry().right() + 20, 
                            _positionAngleSpinBox->geometry().bottom() + 20); 



    /******************************************************************
    * A spin box to set the photometry aperture colour
    *****************************************************************/
    xPos = 10; // was 20
    yPos = sgroup->geometry().bottom() + 20;

    OmSourceGroupBox *colourBox = new OmSourceGroupBox( this,  "Ds9 display", xPos, yPos, 70);

    OmSourceLabel *label1 = new OmSourceLabel(colourBox, "Aperture", 10, 20);

    _spinBoxColour1 = new OmSpinBox( colourBox, "Change the colour of the aperture region", 
				     _colourList.size() - 1, _colourList, _colour1No + 1);

    _spinBoxColour1->setGeometry( label1->geometry().left(), label1->geometry().bottom(), 70, 25);

    connect(_spinBoxColour1, SIGNAL(valueChanged(int)), this, SLOT ( colour1Changed(int)));

    _spinBoxColour1->show();
  


    /******************************************************************
    * A spin box to set photometry background annulus colours
    *****************************************************************/
    
     OmSourceLabel *label2 = new OmSourceLabel( colourBox, "Background", label1->geometry().left(), 
						_spinBoxColour1->geometry().bottom() + 10);
    _spinBoxColour2 = new OmSpinBox( colourBox, "Change the colour of the background annulus", 
				     _colourList.size() - 1, _colourList, _colour2No + 1);
    _spinBoxColour2->setGeometry( label2->geometry().left(), label2->geometry().bottom(), 70, 25);
    connect(_spinBoxColour2, SIGNAL(valueChanged(int)), this, SLOT ( colour2Changed(int)));

    colourBox->resize( max(colourBox->width(), _spinBoxColour2->geometry().right() + 10),   
		       _spinBoxColour2->geometry().bottom() + 10);

    _spinBoxColour2->show();
  

    //*************************************************************
    // The compute button
    //*************************************************************
    xPos = colourBox->geometry().right() + 50; // was 20
    yPos = colourBox->geometry().bottom() - 30;
     

    /*****************************************************************************
    * A help button
    *****************************************************************************/

    OmSourceButton *helpButton = new OmSourceButton(this, " &Help ", xPos, yPos, 30, 
               "Click here for help");
  
  
    connect( helpButton, SIGNAL(clicked()), this, SLOT ( showHelpInformation()) );
   
    QToolTip::add( helpButton, "Click here, or click the right mouse-button,\n""for information on the photometry, etc");
  

    xPos = helpButton->geometry().right() + 20;

    _computeBtn = new OmSourceButton(this , "Compute photometry", xPos, yPos, 30,           
        "Click here to recompute the instrumental magnitude\nusing the selected aperture and background annulus");
    
    connect( _computeBtn,SIGNAL(clicked()), this, SLOT(compute()));
 
    //    _growthCurveBtn = new OmSourceButton(group , "Growth curve",           
    //        "Click here to display an aperture growth-curve");
    //    layout->addWidget( _growthCurveBtn, 1);

 
    //    connect(_growthCurveBtn,SIGNAL(clicked()), this, SLOT(displayGrowthCurve()));
   

    reporter->setProgress(29);
   
 
    // create the logger
    _loggerGroupBox = new OmSourceGroupBox( this, " ",   10, 630, 510, 250);
   

    _logger = new OmSourceLog(_loggerGroupBox); 
    _logger->setGeometry( 10, 20, 490, 120 );
   
    _averageMagList  = new QComboBox(  _loggerGroupBox);
    _averageMagList->setGeometry(10, 170, 350, 30);
    _averageMagList->setDisabled(TRUE);
    QToolTip::add( _averageMagList , "The average-magnitude table\n"
                                     "This table stores the running average magnitude for the selected source\n"
                                     "Computed from all the values stored in the logger table above\n"
                                     "A new entry is added after the apply button is clicked");
    reporter->setProgress(30);
   
   
    /*********************************************************
    * A button to print its contents
    ********************************************************/
    _printAveragesBtn = new OmSourceButton( _loggerGroupBox, "Print averages",  
                           "Click here to print the contents of\nthe average-magnitude table above");
   
    _printAveragesBtn->setGeometry(10, 210, 100 , 35);
    connect(_printAveragesBtn, SIGNAL(clicked()), this, SLOT (print1()) );
   
                                       
    _printAveragesBtn->setDisabled(TRUE);
    
    /*********************************************************
    * A button to delete average-magnitude table contantes
    ********************************************************/
    //   _deleteAveragesBtn = new OmSourceButton(_loggerGroupBox, "Delete table",
    //                          "Click here to delete the contents of\n"
    //                          "the average-magnitude table above" );
  
    // _deleteAveragesBtn->setGeometry(130, 210, 100, 35);
    // connect(_deleteAveragesBtn, SIGNAL(clicked()), this, SLOT (deleteAverageMagList()) );
   
		
    reporter->setProgress(31);
                
    //  _deleteAveragesBtn->setDisabled(TRUE);
   
 
    /*********************************************************
    * A button to print the logger
    ********************************************************/
    _printLogBtn = new OmSourceButton(_loggerGroupBox,  "Print table", 
		     "Click here to print the entries in the logger table above");
    _printLogBtn->setGeometry(_loggerGroupBox->width() - 110, 170, 100 , 35); 

    connect(_printLogBtn, SIGNAL(clicked()), this, SLOT (print2()) );
   
    _printLogBtn->setDisabled(TRUE);
    


  /*********************************************************
    * A button to delete average-magnitude table contantes
    ********************************************************/
    _deleteAveragesBtn = new OmSourceButton(_loggerGroupBox, "Delete table",
                              "Click here to delete the contents of\n"
                              "the average-magnitude table above" );
  
    _deleteAveragesBtn->setGeometry(_printLogBtn->geometry().left(), _printLogBtn->geometry().bottom() + 5, 100, 35);
    connect(_deleteAveragesBtn, SIGNAL(clicked()), this, SLOT (deleteAverageMagList()) );
   
		
    reporter->setProgress(31);
                
    _deleteAveragesBtn->setDisabled(TRUE);
   
    //cout << "L1223 no=" << _sourceNo << " source.magnitude=" << _source.magnitude << endl ;

    reporter->setProgress(32);
   
    LoadSourceDetails();

 
    _source.rawbackgroundcountrate = -1.0;
    
    _eSource = _source;
    _pSource = _source;
  

    reporter->setProgress(33);
   
    // NB In the source-list file the aperture-radius is stored as unbinned pixels
    // Want to display it in the table as actual extraction radius
  
  
    if (_source.extensionflag == 0)
    {
        _source.iMin = -1;
    }    
    else
    {
        _source.iMin = 0;
    }    

    //cout << "L1251 omsourcephotometryDlg.cc  _source.iMin=" << _source.iMin << endl;

    /*******************************************************************
     * Set the first entry in the logger table with the pre-computed parameters
    *********************************************************************/
    _logger->add( _source );


    if (_source.extensionflag == 1)
    {
        _source.iMin = _extendedSourcePhotometryMethod;
    }    


    if ( !_isUVFilter )
    {
        _psf2CorrectionTxt->setDisabled(true); 
   
        _psf2CorrectionEdt->setDisabled(true); 
   
    }
    else
    {

        _ABMagnitudeTxt->setDisabled(true); 
   
        _ABMagnitudeEdt->setDisabled(true);
        _ABMagnitudeErrEdt->setDisabled(true);
        _ABMagnitudeErrTxt->setDisabled(true);
 

        _ABFluxTxt->setDisabled(true); 
        _ABFluxEdt->setDisabled(true); 
        _ABFluxErrEdt->setDisabled(true); 
        _ABFluxErrTxt->setDisabled(true); 

    }


    _magnitude = new float[1000];
    _magnitudeError = new float[1000];
    _count = 0;

    computeAverage();
    _computeBtn->setDisabled(true);


    /**********************************************************
    * Exit and cancel buttons
    **********************************************************/    
    yPos = this->height() - 50;
    xPos = this->width() / 3;


    _finishButton = new OmSourceButton( this, "Okay",
         "Click here to return to the main window");
      
    _finishButton->setGeometry(xPos, yPos, 70, 35);

    _finishButton->setDisabled(true);
    connect(_finishButton, SIGNAL(clicked()), this, SLOT(accept()));
    reporter->setProgress(34);
   
 
    xPos += 90;
  
    _cancelButton = new OmSourceButton( this, "Cancel", 
        "Click here to keep the original source parameters and return to the main window");
    _cancelButton->setGeometry(xPos, yPos, 70, 35);
    connect(_cancelButton, SIGNAL(clicked()), this, SLOT(cancel()));
   
     
    reporter->setProgress(35);
   

    reporter->setProgress(36);

    
    reporter->setProgress(37);
 
 
    /***************************************************************   
    *
    ***************************************************************/
    // add an information  menu:
    QPopupMenu* infoMenu = new QPopupMenu;
    
    infoMenu->insertItem("&Help", parent, SLOT(showHelpInformation()) );
 
    infoMenu->insertItem( "&Obs details",  parent, 
          SLOT(showObservationDetails()), Qt::CTRL+Qt::Key_O );
 
    infoMenu->insertItem( "&Image details",  parent, 
          SLOT(showImageDetails()), Qt::CTRL+Qt::Key_I );

    reporter->setProgress(38);

    QMenuBar* menuBar = new QMenuBar(this);
    menuBar->insertItem("Observation &Information", infoMenu);
    reporter->setProgress(39);

    // Get the background mode from the image

    _backgroundMode = F90MODPROC(omsource_glue, getthebackgroundmode)();
    //cout << "L1355 backgroundMode="<<_backgroundMode << endl;

    _backgroundUserValue = _backgroundMode;  
    reporter->setProgress(40);

    text.sprintf("Uses your background value (counts/pxel)\n"
                 "Currently set at the image mode (%.1f) to subtract the background", _background);
    QToolTip::add( _backgroundRadioBtn[2] , text);



    //    setGeometry(0, 0, this->width() - 20, this->height());      

   setGeometry(0, 0, _loggerGroupBox->geometry().right() + 10, this->height());      


    reporter->setProgress(41);

    _pSource.axialRatio = 1.0;
    _pSource.alpha = 0.0;
    _pSource.extensionflag = false; 
  
    _pSource.innerbackgroundradius = _innerBckRadius;
    _pSource.outerbackgroundradius = _outerBckRadius;   
    _pSource.iMin = -1;
 
  
    _eSource.photometryradius = max(3.0, _source.semib * 3.0);
    _eSource.innerbackgroundradius = _eSource.photometryradius + 4.0; 
    _eSource.outerbackgroundradius =  _eSource.innerbackgroundradius + 6.0;   
    _eSource.axialRatio = _source.semia / _source.semib;     
    _eSource.extensionflag = true; 
    _eSource.iMin = -2;


    if (_source.extensionflag)
    {
       
	_sourceTypeRadioBtn[1]->setChecked( true );
 
       _positionAngleSpinBox->setValue(int(_originalSource.alpha));

    }
    else
    {
    
 	_sourceTypeRadioBtn[0]->setChecked( true );
        
    
    } 

    initApertureSpinBoxes();
 

    delete reporter;

    _timer = new QTimer(this);
    connect(_timer, SIGNAL(timeout()), SLOT(updateDisplay()) );
   

    sourceTypeHasChanged( _source.extensionflag );



}
/**************************************************************
*
*  
*  Destroys the object and frees any allocated resources
*
*
**************************************************************/
PhotometryDlg::~PhotometryDlg()
{
    delete [] _magnitude;
    delete [] _magnitudeError;


    // Delete the background regions
    //    F90MODPROC(omsource_glue, deletebackgroundlist)();


    /****************************************************
    *
    ****************************************************/


    F90MODPROC(omsource_glue, deletebackgroundlist)();
    F90MODPROC(omsource_glue, deletebackgroundregions)();
    BackgroundDlg::_backgroundList.clear();

      
    // no need to delete child widgets, Qt does it all for us
  
}
/*********************************************
* cancel -
*  
*********************************************/

void PhotometryDlg::cancel()
{

    F90MODPROC(omsource_glue, replace)(_sourceNo, _originalSource);
      
    reject();

}
/***********************************************
* 
*************************************************/
void PhotometryDlg::LoadSourceDetails()
{


  //printf("L1470 photometryDlg \n");
  OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
  _source = mySources[_sourceNo];
 
 
  QString text;
  
  float totalRate =  _source.rawcountrate +  _source.rawbackgroundcountrate;
  float error;
   
  if (_source.rawbackgroundcountrateerror > 0.0)
    error =  sqrt(_source.rawcountrateerror * _source.rawcountrateerror +
		  _source.rawbackgroundcountrateerror * _source.rawbackgroundcountrateerror);
  else
    {
      error = 0.0;
      _source.rawbackgroundcountrateerror = 0.0;
      
    }
  _rawTotalRateEdt->setText(text.sprintf("%8.2f",  totalRate));
  
  _rawTotalRateErrEdt->setText(text.sprintf("%8.2f",  error));;
  
  _rawBackgroundRateEdt->setText(text.sprintf("%8.2f",  _source.rawbackgroundcountrate));
  
  _rawBackgroundRateErrEdt->setText(text.sprintf("%8.2f",  _source.rawbackgroundcountrateerror));
  
 
  _rawBackgroundSubtractedRateEdt->setText(text.sprintf("%8.2f",  _source.rawcountrate));
  
  _rawBackgroundSubtractedRateEdt->setText(text.sprintf("%8.2f", _source.rawcountrate  ));
  

     
   
  _rawBackgroundSubtractedRateErrEdt->setText(text.sprintf("%8.2f",_source.rawcountrateerror));
  
  // here the source and background count rates are scaled to the photometry aperture (35 pixels 
  // for the UV-filters)
  //cout << "L1510 corrCountRate=" <<  _source.corrcountrate << " corrBkgRate=" << _source.corrbackgroundcountrate<< endl; 
  //cout << "L1511 photometry radius=" << _source.photometryradius << endl;
  //cout << "L1512 psf1correction=" << _source.psf1correction << " psf2correction="<<_source.psf2correction <<endl;
 
  //*********************************************************************************************
  // 2012-10-13 vny Checked: here _source.photometryradius is actually not the photometry radius
  // but the source exraction radius (by changing the aperture it is changing exactly in the 
  // same way
  //**********************************************************************************************
  
  // Corrected count rates
  //*************************************************************
  // Here the source CL-correctedcount rate includes the background
  // So, adding the background to it is a mistake 
  //totalRate =  _source.corrcountrate +  _source.corrbackgroundcountrate;
  //************************************************************
  //totalRate =  _source.corrcountrate;
  //_source.corrcountrate=_source.corrcountrate -  _source.corrbackgroundcountrate;
  //************************************************************
  // 2012-10-13 vny: restoring the totalRate as it was initially correct
  totalRate =  _source.corrcountrate +  _source.corrbackgroundcountrate;

  //*************************************************************************
  // 2012-10-13 vny: the source raw count rate is changing if the 
  // source extraction radius is changed. The same happens to the background,
  // which is probably scaled to the source extraction region
  //**************************************************************************
  //cout << "L1524 raw count rate=" <<  _source.rawcountrate 
  //     << " error=" <<  _source.rawcountrateerror << endl;
  //cout << "L1526 corr count rate=" <<  _source.corrcountrate 
  //     << " error=" <<  _source.corrcountrateerror << endl;
  //cout << "L1528 background raw count rate=" <<  _source.rawbackgroundcountrate 
  //     << " error=" <<  _source.rawbackgroundcountrateerror << endl;
  //cout << "L1530 background corr count rate=" <<  _source.corrbackgroundcountrate 
  //     << " error=" <<  _source.corrbackgroundcountrateerror << endl;


  if (_source.corrbackgroundcountrateerror > 0.0)
    error =  sqrt(_source.corrcountrateerror * _source.corrcountrateerror +
		  _source.corrbackgroundcountrateerror * _source.corrbackgroundcountrateerror);
  else
    {
      error = 0.0;
      _source.corrbackgroundcountrateerror = 0.0;
    }
  _corrTotalRateEdt->setText(text.sprintf("%8.2f",  totalRate));
  

  _corrTotalRateErrEdt->setText(text.sprintf("%8.2f",  error));;
  
  _corrBackgroundRateEdt->setText(text.sprintf("%8.2f",  _source.corrbackgroundcountrate));
  _corrBackgroundRateErrEdt->setText(text.sprintf("%8.2f",  _source.corrbackgroundcountrateerror));
  

 
  _corrBackgroundSubtractedRateEdt->setText(text.sprintf("%8.2f", _source.corrcountrate));
  _corrBackgroundSubtractedRateErrEdt->setText(text.sprintf("%8.2f", _source.corrcountrateerror));
  
  _magnitudeEdt->setText(text.sprintf("%8.2f",  _source.magnitude));
  _magnitudeErrEdt->setText(text.sprintf("%8.2f",  _source.magnitudeerror));
  _signalToNoiseEdt->setText(text.sprintf("%8.2f",  _source.significance));      
  

  /******************************************************
   * Compute the AB magnitude anf flux
   ******************************************************/
  float ABMag = -1.0, ABMagErr = -1.0, ABFlux = -1.0, ABFluxErr = -1.0;

  computeABMagsAndFluxes(_source.corrcountrate, _source.corrcountrateerror, 
			 ABMag, ABMagErr, ABFlux, ABFluxErr);


  if (!_isUVFilter)
    {
      _ABMagnitudeEdt->setText(text.sprintf("%8.2f",  ABMag));
      _ABMagnitudeErrEdt->setText(text.sprintf("%8.2f",  ABMagErr));
      _ABFluxEdt->setText(text.sprintf("%10.5e",  ABFlux));
      _ABFluxErrEdt->setText(text.sprintf("%10.5e",  ABFluxErr));
    }


  /******************************************************************************
   *
   *******************************************************************************/
  float deadFractionCorrection = 1.0 / (1.0 - _imageDetails->deadFraction);


  // Coincedence-loss corrections
  _coincCorrectionEdt1->setText(text.sprintf("%5.3f",  _source.semiaerr * deadFractionCorrection));
  
  _coincCorrectionEdt2->setText(text.sprintf("%5.3f",  _source.semiberr * deadFractionCorrection));


  //cout << "L1590 psf1 correction=" <<  _source.psf1correction << endl;

   
  _psf1CorrectionEdt->setText(text.sprintf("%5.3f",  (1.0 + _source.psf1correction / 100.0)));
   

  if ( _isPointSource && _isUVFilter )
    {
      _psf2CorrectionEdt->setText(text.sprintf("%5.3f",  (1.0 + _source.psf2correction / 100.0)));
      
      
    }


  //cout << "L1604 Omsourcephotometrydlg.cc deadfraction=" << _imageDetails->deadFraction << endl;
  //cout << "***********************************************************" << endl;
 
 
  _tdsCorrectionEdt->setText(text.sprintf("%5.3f",  _source.tdscorrection));


}
/******************************************************
* initApertureSpinBoxes
* Purpose- Initialises the spin boxes with the default
* values
******************************************************/

void PhotometryDlg::initApertureSpinBoxes()
{


    /************************************************************************
    *The aperture radius
    * Need to change the tool-tips
    *************************************************************************/
    QToolTip::remove( _apertureSpinBox );
    QToolTip::remove( _apertureTxt );
  

    QString text; 
    if (_source.extensionflag == 0)
    {

        _apertureTxt->setText( "Aperture" );

        _apertureSpinBox->setMaxValue(int(_apertureRadius + 0.1));
        _apertureSpinBox->setMinValue(int(_apertureRadius / 2.0 + 0.1));
   
        if (_source.photometryradius == 0.0)
            _apertureSpinBox->setValue( _apertureSpinBox->maxValue() );
        else  
            _apertureSpinBox->setValue((int)(_source.photometryradius));
  

        QTextOStream( &text ) << "The aperture radius (allowed values=" << _apertureSpinBox->minValue()
                          << " - " 
                          << _apertureSpinBox->maxValue() << " pixels)"; 
                      
        QToolTip::add( _apertureTxt, text);
        QToolTip::add( _apertureSpinBox, text);

  
        // The inner background annulus  
        _innerBckSpinBox->setMinValue( _apertureSpinBox->value()    );
        _innerBckSpinBox->setValue(   (int)_innerBckRadius   );
        _innerBckSpinBox->setMaxValue( int(_innerBckRadius) + 20 );




        // The outer background annulus  
        _outerBckSpinBox->setMinValue(_innerBckSpinBox->value() + 2);
       
        _outerBckSpinBox->setValue( (int)_outerBckRadius );
        _outerBckSpinBox->setMaxValue( (int)_outerBckRadius + 20);
 
 
   
    }
    else // Extended source
    {     

        _apertureSpinBox->setMinValue( max(3, int( _source.semib + 0.1)) );         
        _apertureSpinBox->setMaxValue( _apertureSpinBox->minValue() + 20       );   
        _apertureSpinBox->setValue( max(3, int(_source.semib * 3.0 + 0.1)) );
      

	QTextOStream( &text ) << "The semi-minor axis of the aperture (pixels) (allowed values=" << _apertureSpinBox->minValue()
                          << " - " 
                          << _apertureSpinBox->maxValue() << " pixels)"; 
 

        QToolTip::add( _apertureTxt, text);  
        QToolTip::add( _apertureSpinBox, text );
        
       
        // The inner background annulus  
        _innerBckSpinBox->setMinValue( _apertureSpinBox->value() );
        _innerBckSpinBox->setMaxValue( _apertureSpinBox->value() + 20 );
        _innerBckSpinBox->setValue(  _apertureSpinBox->value() + 2 );
  

        // The outer background annulus        
        _outerBckSpinBox->setMinValue( _innerBckSpinBox->value() + 5 );
        _outerBckSpinBox->setMaxValue(  _innerBckSpinBox->value() + 25 );      
        _outerBckSpinBox->setValue(   _innerBckSpinBox->value() + 5); 
  


 
    }



    //    cout << "initaperturespinboxes innerspinminvalue=" << _innerBckSpinBox->minValue() << " max=" << _innerBckSpinBox->maxValue() << endl; 
    //  cout << "initaperturespinboxes outerspinminvalue=" << _outerBckSpinBox->minValue() << " max=" << _outerBckSpinBox->maxValue() << endl; 
    //  cout << "inner set to=" << _innerBckSpinBox->value() << " outer=" << _outerBckSpinBox->value() << endl; 

    //  cout << "_innerBckRadius =" << _innerBckRadius << " outer=" << _outerBckRadius << endl;

    setToolTips();   
   
}
/******************************************************
* sourceHasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::apertureRadiusHasChanged(int value)
{
     
    _computeBtn->setEnabled(true);
    
    _source.photometryradius = value;


    _innerBckSpinBox->setMinValue( value );
    
    if (value > _innerBckSpinBox->minValue() )
    {
   
        _innerBckSpinBox->setMaxValue( value + 30 );
        _innerBckSpinBox->setValue( value);
    }
    setToolTips();

    //    cout << "Line 1487 aperture radius has changed line 1487\n";

    startTimer();
}
/******************************************************
* 
******************************************************/
void PhotometryDlg::setToolTips()
{

    QString text1, text2;
    if ( _source.extensionflag == 0)
    {    
	QTextOStream( &text1 ) << "The inner background annulus radius (allowed values=" << _innerBckSpinBox->minValue()
                          << " - " 
                          << _innerBckSpinBox->maxValue() << " pixels)"; 
                      
 
	QTextOStream( &text2 ) << "The outer background annulus radius (allowed values=" << _outerBckSpinBox->minValue()
                          << " - " 
                          << _outerBckSpinBox->maxValue() << " pixels)"; 
                      
    }
    else
    {


	QTextOStream( &text1 ) << "The semi-minor axis of the inner background annulus (allowed values=" << _innerBckSpinBox->minValue()
                          << " - " 
                          << _innerBckSpinBox->maxValue() << " pixels)"; 

  
	QTextOStream( &text2 ) << "The semi-minor axis of the outer background annulus (allowed values=" << _outerBckSpinBox->minValue()
                          << " - " 
                          << _outerBckSpinBox->maxValue() << " pixels)"; 

     

    }
    QToolTip::remove( _innerBckSpinBox );
    QToolTip::remove( _innerBckTxt );
    QToolTip::add( _innerBckTxt, text1);
    QToolTip::add( _innerBckSpinBox, text1);

    QToolTip::remove( _outerBckSpinBox );
    QToolTip::remove( _outerBckTxt );
    QToolTip::add( _outerBckTxt, text2);
    QToolTip::add( _outerBckSpinBox, text2);



}

/******************************************************
* 
******************************************************/
void PhotometryDlg::startTimer()
{

  //  cout << "start timer line 1546\n";
    if (_timer == 0) return;

    if (_timer->isActive())
    {
        _timer->stop();
    }
    _timer->start(1000, FALSE ); // One second timer
    
    //    cout << "line 1554 timer started\n";
}
/******************************************************
* innerAnnulusRadiusGasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::innerAnnulusRadiusHasChanged(int value)
{
  
    _computeBtn->setEnabled(true);
 
    _outerBckSpinBox->setMinValue( value + 2);
    


    _outerBckSpinBox->setValue( max( _outerBckSpinBox->value(), value + 5) );

    _outerBckSpinBox->setMaxValue( max(_outerBckSpinBox->value() + 5, _outerBckSpinBox->maxValue()) );


    _source.innerbackgroundradius = value;




    setToolTips();
    startTimer();
    
      
       
}
/******************************************************
* outerAnnulusRadiusGasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::outerAnnulusRadiusHasChanged(int value)
{  
    _computeBtn->setEnabled(true);
    _source.outerbackgroundradius = value;

  
    setToolTips();

    startTimer();
    
       
     
}
/******************************************************
* eccentricityHasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::axialRatioHasChanged(const QString& textValue)
{  
    _computeBtn->setEnabled(true);
    
    char *endPtr;
    float value = strtod( (const char *)textValue, &endPtr);
    
    _source.axialRatio  = value;
     
  
    startTimer();
       
   
}
/******************************************************
* positionAngleasChanged
* Purpose- called when user activates a spin button control
******************************************************/
void PhotometryDlg::positionAngleHasChanged(int value)
{  
    _computeBtn->setEnabled(true);
  
    _source.alpha = float(value);

    startTimer();
    
}
/*********************************************************
 *
 ********************************************************/
void PhotometryDlg::updateDisplay()
{
       
    _timer->stop();

    //    cout << "Line 1641 updatedisplay\n";
  
    _source.number = _sourceNo;
    _source.photometryradius = _apertureSpinBox->value();
    _source.innerbackgroundradius = _innerBckSpinBox->value();
    _source.outerbackgroundradius = _outerBckSpinBox->value();
    //    _source.alpha = _positionAngleSpinBox->value();

    
    //    _source.axialRatio  = _axialRatioSpinBox->realValue();
     
 



    //        cout << "Update display photometry radius=" << _source.photometryradius << endl;
    //	cout << "theta=" << _source.theta << " alpha=" << _source.alpha << endl;
    //	cout << "axial ratio=" << _source.axialRatio << endl;
    //	cout << "semi a= " << _source.semia << " semib=" << _source.semib << endl;
    //     cout << " inner background="<< _source.innerbackgroundradius << " outer=" << _source.outerbackgroundradius << endl; 



    _display->zoomTo( _source, _zoomFactor, _colour1.c_str(), _colour2.c_str() );




    _display->displayCurrentSourceList1( _oldRegionsColour.c_str(), false );


    _display->displayBackgroundRegions( BackgroundDlg::_backgroundList, OmSourceBrowser::_backgroundRegionsColour.c_str() );

 
    OmSourceRegions *points1 = OmImageRegions::GetNewRegions( _display, _nx, _ny );
     

   


    if (points1) 
    {
        delete(points1);
        points1 = 0;	  
    }





    //cout << "L1941 updatedisplay\n";

   

}
/******************************************************
* recompute
* This is activated from OmSourceEditor when the apply
* button is clicked.
*******************************************************/
void PhotometryDlg::compute()
{

  //cout << "L1954 OMSOURCEPHOTOMETRYDLG Compute \n";
  //cout << "L1955 background="<<_background << " backgroundUserValue=" << _backgroundUserValue << endl;
  if (!_fixedBackground)
    {
      _source.rawbackgroundcountrate = _background;
      
    }
  else
    { 
      _source.rawbackgroundcountrate =  _backgroundUserValue;   
   

    }
 
  //cout << "OMSOURCEPHOTOMETRYDLG Compute line 2017\n";

  //cout << "L1970 imin=" << _source.iMin << " extendedphotometrymethod=" 
  //     << _extendedSourcePhotometryMethod << " extensionflag=" << (int)_source.extensionflag << endl;




  _source.photometryradius = _apertureSpinBox->value();


  //cout << "L1979 alpha=" << _source.alpha << endl;
  //cout << "L1980 rawbackgroundcountrate=" << _source.rawbackgroundcountrate << endl;
  //cout << "L1981 Fixed background=" << _fixedBackground << endl;


  //cout << "L1984 imin=" << _source.iMin << " extensionflag=" << _source.extensionflag << endl;


  if( _source.extensionflag == 1)
    {


      /******************************************************************************
       *
       * Set the extended-source photometry method
       *
       ******************************************************************************/
      //        cout << "Omsourcephotometrydlg.cc line 1994- extendedSourcePhotometryMethod=" << _extendedSourcePhotometryMethod << endl;
      F90MODPROC(omsource_old, setesourcephotometrymethod)( _extendedSourcePhotometryMethod);
      _source.iMin = _extendedSourcePhotometryMethod;


    }


  //cout << "L2004 OMSOURCEPHOTOMETRYDLG Compute \n";


  //********************************************************************************************
  // Compute the photometry by use of fortran modules in omsource_glue.f90 and omsource_old.f90 
  //********************************************************************************************    
  F90MODPROC(omsource_glue, replace)( _sourceNo, _source);
  

  //cout << "L2011 OMSOURCEPHOTOMETRYDLG Compute \n";

   
  if(_backgroundRadioBtn[1]->isChecked())
    {
      

      
      if ( BackgroundDlg::_backgroundList.size() == 0) 
        {
	  
	  QMessageBox::critical( 0, "omsource",
				 QString("No regions have been selected for background determination\n\n\n") + 
				 QString("Please select one or more background regions")); 
	  
	  
	  return;
        }
      
      
    }

 

  //cout << "L2035 OMSOURCEPHOTOMETRYDLG Compute\n";


  _finishButton->setEnabled(true);
  _computeBtn->setDisabled(true);
 




  //cout << "L2045 imin=" << _source.iMin << endl;
  //cout << "L2046 raw background count rate=" <<    _source.rawbackgroundcountrate  << endl;




  // Display the dialogue to do the photometry
  QString caption =  "Computing photometry- please wait";
  ProcessDlg *processDlg = new ProcessDlg(this, _sourceNo, caption, 
					  ProcessDlg::aperturePhotometry);
   
  processDlg->exec();

  


  // Retrieve the new source parameters
  OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
  _source = mySources[_sourceNo];


  //cout << "L2067 no=" << _sourceNo << " source.magnitude=" << _source.magnitude << endl ;


  //cout << "L2070 apertureradius=" << _source.photometryradius << endl;


  _source.rawbackgroundcountrateerror = _backgroundUserValue;
 
  //cout << "L2075 imin=" << _source.iMin << " extendedphotometrymethod=" 
  //     << _extendedSourcePhotometryMethod << " extensionflag=" << (int)_source.extensionflag << endl;




  _logger->add(_source );
  
  LoadSourceDetails();
  _averageMagList->setEnabled(true);
  computeAverage();
  
}

/******************************************************
* print
******************************************************/
void PhotometryDlg::print()
{
#ifndef QT_NO_PRINTER

    QPrinter printer; 
    if ( printer.setup(this) ) {                // opens printer dialog
        printer.setFullPage(TRUE);              // we'll set our own margins
	QPainter p;
	p.begin( &printer );                    // paint on printer
	p.setFont( p.font() );
	QFontMetrics fm = p.fontMetrics();
	QPaintDeviceMetrics metrics( &printer ); // need width/height
                                                 // of printer surface
    
        /*********************************************
	* Print what ever
	********************************************/
        (this->*Print)(&printer, &p,  &fm,  &metrics);

	p.end();                                // send job to printer
    }
#endif
}

/*********************************************************
* print1
**********************************************************/
void PhotometryDlg::print1()
{



    _timer->stop();


    Print = &PhotometryDlg::printAverages;
    print();

   startTimer();


}
/*********************************************************
* print2
**********************************************************/
void PhotometryDlg::print2()
{   

   _timer->stop();



  
    Print = &PhotometryDlg::printLog;
    print();


   startTimer();



}

/*********************************************************
* printAverages
* Prints the contents of the combo box that stores
* the average magnitudes
*********************************************************/
void PhotometryDlg::printAverages(QPrinter* printer, QPainter* p,  
               QFontMetrics* fm,  QPaintDeviceMetrics* metrics)
{
    const int MARGIN = metrics->logicalDpiX() / 2; // half-inch margin
    int yPos        = MARGIN;               // y position for each line


    printHeading(p,  fm, metrics, MARGIN, yPos);
 

    for( int i = 0 ; i < _averageMagList->count(); i++ ) 
    {
        if ( printer->aborted() )
            break;
        if ( yPos + fm->lineSpacing() > metrics->height() - MARGIN ) 
        {
                // no more room on this page
                if ( !printer->newPage() )          // start new page
                    break;                          // some error
                yPos = MARGIN;                      // back to top of page
        }
        p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, _averageMagList->text(i));
        yPos += fm->lineSpacing();
    }

}

/*****************************************************************************
*
* printHeading
****************************************************************************/
void PhotometryDlg::printHeading(QPainter* p,  
                                  QFontMetrics* fm,  
                                  QPaintDeviceMetrics* metrics,
                                  const int MARGIN, int &yPos)
{
    QDateTime date = QDateTime::currentDateTime();  // The current date and time
    
    QString text = QString("Listing produced by ") + omsourceVersionNo() + QString("  ") + date.toString();  
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += 2 * fm->lineSpacing();
   
    text = QString("TELESCOPE=") + _obsDetails->telescope + " INSTRUMENT=" + _obsDetails->instrument;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = "OBS_ID=" + _obsDetails->obsId + " EXP_ID=" + _obsDetails->expId;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = "DATE-OBS=" + _obsDetails->dateObs + " DATE-END=" + _obsDetails->dateEnd;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = "OBJECT=" + _obsDetails->object + " OBSERVER=" + _obsDetails->observer;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text.sprintf("FILTER=%s EXPOSURE=%d (SECONDS)", (const char *)_obsDetails->filter, 
           (int)_obsDetails->exposure);
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += 5 * fm->lineSpacing();

}
/*********************************************************
* printLog
* Prints the contents of the table that stores the
* user photometry calculations
*********************************************************/
void PhotometryDlg::printLog(QPrinter* printer, QPainter* p,  
               QFontMetrics* fm,  QPaintDeviceMetrics* metrics)
{
    const int MARGIN = metrics->logicalDpiX() / 2; // half-inch margin
    int yPos        = MARGIN;               // y position for each line

    printHeading(p, fm, metrics, MARGIN, yPos);


    QString text;
    text.sprintf("Source no %d - photometry calculations", _sourceNo);
    p->drawText (MARGIN, yPos, text); 
    yPos += 2 * fm->lineSpacing();
    QString heading[] = {"Photometry aperture radius (unbinned pixels)",
                         "Photometry inner background annulus radius (unbinned pixels)",
                         "Photometry outer background annulus radius (unbinned pixels)",
                         "Instrumental magnitude (corrected for coincidence losses & psf corrections)",
                         "Instrumental magnitude error",
                         "Signal-to-noise ratio)",
                         "Coincidence-loss correction (%)"}; 
 
    for (int i = 0; i <  _logger->numCols(); i++)
    {
        QString text;

        text.sprintf("Column %d=%s", i + 1, (const char *)heading[i]); 
        p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);

        yPos += fm->lineSpacing();
        
    }
     
    yPos += fm->lineSpacing();
   
    for( int i = 1 ; i < _logger->numRows(); i++ ) 
    {
        if ( printer->aborted() )
            break;
        if ( yPos + fm->lineSpacing() > metrics->height() - MARGIN ) 
        {
                // no more room on this page
                if ( !printer->newPage() )          // start new page
                    break;                          // some error
                yPos = MARGIN;                      // back to top of page
        }

        QString text;
        for (int j = 0; j < _logger->numCols(); j++)
	{
	  text += _logger->text(i, j) + QString("        ");
           

        }
   
       p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);


        yPos += fm->lineSpacing();
    }

}
/*********************************************
 *
 *******************************************/
void PhotometryDlg::deleteAverageMagList()  
{ 
    _averageMagList->clear();
    
    _logger->setNumRows(0);

    _printAveragesBtn->setDisabled(true);
    _deleteAveragesBtn->setDisabled(true);
    _count = 0;
    repaint();
}; 


/******************************************************
* edit
*******************************************************/

void PhotometryDlg::computeAverage()
{
    
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
     
    // Recompute the average magnitude 
      
    _magnitude[_count] = mySources[_sourceNo].magnitude;
    _magnitudeError[_count] = mySources[_sourceNo].magnitudeerror;
    
    if (_count > 0) 
    {

        float mean, standardDeviation;
       
        ComputeAverageMagnitude(_magnitude, _magnitudeError, _count + 1, mean, standardDeviation);
        QString text;
        text.sprintf("Average magnitude for source %d=%5.2f+/-%5.2f (n=%d)", 
               _sourceNo, mean, standardDeviation, _count + 1); 
        
        _averageMagList->setEnabled(true);

        _printLogBtn->setEnabled(true);
        _printAveragesBtn->setEnabled(true);
        _deleteAveragesBtn->setEnabled(true);


        _averageMagList->insertItem(text);
        _averageMagList->setEditText(text);

        _averageMagList->setCurrentItem(_averageMagList->count() - 1); 
    }
    _count++;

     
}

/***************************************************************
*
* The user has decided to change the extension flag of the source
* Point to extended of extended to point
*
**************************************************************/

void PhotometryDlg::sourceTypeHasChanged( int type )
{

 
    if (type == 0)
    {

        _axialRatioTxt -> setDisabled(true);
        _axialRatioSpinBox -> setDisabled(true);
        _positionAngleTxt -> setDisabled(true);
        _positionAngleSpinBox -> setDisabled(true);
        _source = _pSource;
        _backgroundRadioBtn[3]->setDisabled( true );
        if( _isUVFilter)
	{
            _psf2CorrectionTxt->setEnabled(true);
            _psf2CorrectionEdt->setEnabled(true);
        }

        _isPointSource = true; 
        _isExtendedSource = false;
    
     


    }
    else
    {

        _source = _eSource;
        _axialRatioTxt -> setEnabled(true);
 
        _axialRatioSpinBox -> setEnabled(true);
        _positionAngleTxt -> setEnabled(true);
 
        _positionAngleSpinBox -> setEnabled(true);    
        _backgroundRadioBtn[3]->setEnabled( true );

        if( _isUVFilter )
	{
            _psf2CorrectionTxt->setDisabled( true );
            _psf2CorrectionEdt->setDisabled( true );
        }

     

        _isPointSource = false; 
        _isExtendedSource = true;
 

    }


    initApertureSpinBoxes();
    startTimer();


}     

/****************************************************************
*
***************************************************************/

void PhotometryDlg::showPhotometryInformation()
{

   
  static const char* sayings[] = {
    //    static const QString sayings[] = {
     "<center><i>Overview of photometry</i></center>",

    "<b>Step 1 - Aperture Counts:</b><br>"
    "<hr><br><br>"
    "<big>Sum up the pixel counts within the aperture </big><br><br>"
    "<center><i>-- H.L. Mencken</i></center>",

    "<b>Step 2- Background Estimation:</b><br>"
    "<hr><br><br>"
    "<big>Obtain an estimate of the background<br>"
    "from the pixels within the background aperture<br>"
    
    "These are great mysteries.</big><br><br>"
    "<center><i>-- Geoffrey James, \"The Tao of Programming\"</i></center>",

    "<b>Obtain the Source Counts:</b><br>"
    "<hr><br><br>"
    "<big>Subtract the background from the total counts</big><br><br>"
    "<center><i>-- Martin Mull</i></center>",

    "<b>Saying 4:</b><br>"
    "<hr><br><br>"
    "<big><b>The Least Successful Executions</b><br>"
    "<twocolumn><p>      History has furnished us with two executioners worthy of attention. "
    "The first performed in Sydney in Australia.  In 1803 three attempts were "
    "made to hang a Mr. Joseph Samuels.  On the first two of these the rope "
    "snapped, while on the third Mr. Samuels just hung there peacefully until he "
    "and everyone else got bored.  Since he had proved unsusceptible to capital "
    "punishment, he was reprieved.</p>"
    "<p>        The most important British executioner was Mr. James Berry who "
    "tried three times in 1885 to hang Mr. John Lee at Exeter Jail, but on each "
    "occasion failed to get the trap door open.<!p>"
    "<p>        In recognition of this achievement, the Home Secretary commuted "
    "Lee's sentence to \"life\" imprisonment.  He was released in 1917, emigrated "
    "to America and lived until 1933.</p></twocolumn></big><br><br>"
    "<center><i>-- Stephen Pile, \"The Book of Heroic Failures\"</i></center>",

    "<b>Saying 5:</b><br>"
    "<hr><br><br>"
    "<big>If you can, help others.  If you can't, at least don't hurt others.</big><br><br>"
    "<center><i>-- the Dalai Lama</i></center>",

    "<b>Saying 6:</b><br>"
    "<hr><br><br>"
    "<big>Television has brought back murder into the home -- where it belongs.</big><br><br>"
    "<center><i>-- Alfred Hitchcock</i></center>",

    "<b>Saying 7:</b><br>"
    "<hr><br><br>"
    "<big>I don't know who my grandfather was; I am much more concerned to know "
    "what his grandson will be.</big><br><br>"
    "<center><i>-- Abraham Lincoln</i></center>",

    0
};


    HelpDlg *helpDlg = new HelpDlg(this, sayings);


    

    helpDlg->exec();
    
     
   
 
}
/***********************************************************
*
*
*
***********************************************************/
//void PhotometryDlg::mousePressEvent( QMouseEvent* event)
//{
//  QApplication::beep();
//  if ( event->button() == RightButton )
//  {   

//      QPopupMenu *informationMenu  = new QPopupMenu( this );
    
//      InformationMenu(parentWidget(), informationMenu);
    
 
   

      //      informationMenu->insertItem( "&Photometry information",  this, 
      //          SLOT(showPhotometryInformation()), Qt::CTRL+Qt::Key_I );
 
   
//      informationMenu->exec(QCursor::pos() );

  
//      delete informationMenu;
      
    
//  }
  
//}   

/**********************************************************************************
*
*
**********************************************************************************/



/***************************************************
* Displays the background dialogue that
* allows the user to select circular regions
* for background determination
***************************************************/
void PhotometryDlg::showBackgroundDlg()
{
   
    BackgroundDlg *backgroundDlg = new BackgroundDlg(this, _display, &_source, _zoomFactor);
    


    backgroundDlg->exec();
    
    _backgroundUserValue = backgroundDlg->getBackgroundMode();  
    _backgroundRegionsValue = _backgroundUserValue;   
      

    _source.iMin = -3;
    
    _extendedSourcePhotometryMethod = _source.iMin;

    //cout << "PhotometryDlg line 2049 _background=" << _background << endl;


  
 
}
/******************************************************
 *
 *****************************************************/
void PhotometryDlg::stopTimer()
{
  if (_timer == 0) return;
   _timer->stop();
   // cout << "Line 2062 stopTimer aperture radius=" << _source.photometryradius << endl;
  
}

/***************************************************
 *
 ***************************************************/
void PhotometryDlg::displayGrowthCurve()
{
  
  //    Graph *graph = new OmSourceGraph(this, &_originalSource, 
  //           "Radius (pixels)", "Delta magnitude",
  //           "APERTURE GROWTH-CURVE");    

  //    GraphDlg *graphDlg = new GraphDlg(this, graph);
   
   
  //    graphDlg->exec();
     

  //    delete graph;
   
}
/***************************************************
*
*
*
*
*
***************************************************/
void PhotometryDlg::updateBackgroundDetermination(int index)
{


    _computeBtn->setEnabled(true);


    //cout << "Line 2634 - updatebackgrounddetermintaion- index=" << index << endl;

    _source.iMin = 0;


    switch(index)
    {
    case (0):   // Background from annulus
        _backgroundBtn->setDisabled(true);
        _background = -1.0;        
        _fixedBackground = false;
        _source.iMin = -1;

     
	break; 
    case (1):   // Background from user-selected regions

 
        _fixedBackground = true;
        _backgroundBtn->setEnabled(true);
        _computeBtn->setEnabled(true);
        _background = _backgroundRegionsValue;   

 
        if ( BackgroundDlg::_backgroundList.size() == 0)
        {


	    showBackgroundDlg();

	   
        }
        _source.iMin = -3;


        break;
    case (2):  // User-fixed background
    {
      /*****************************************************
      * Background subtraction using the user-supplied value
      *****************************************************/
       _backgroundBtn->setDisabled(true);
       _fixedBackground = true;
    
       _background = _backgroundUserValue;   
       
       bool ok;
       float value = _background > 0.0 ? _background : _backgroundMode; 
       float minValue =  max(0.0001, _backgroundMode - 20.0);
       float maxValue = _backgroundMode + 20.0;
       QString text;
       text.sprintf("%s%6.1f%s%6.1f%s%6.1f%s%6.1f", "Please change if required-\n"
		    "The allowed range of values is ", minValue, "-", maxValue, 
                    "\nThe computed mode value is", _backgroundMode,
                    "\nThe last user value was ", _backgroundUserValue);
       double res = QInputDialog::getDouble( "Please select your background value (counts/pixel)", 
                  text, (double)value, (double)minValue,
                   (double)maxValue, 1, &ok, this );  // The 1 is the number of decimal places
      
       if ( ok ) {
 
           // user entered something and pressed OK
           _background = res;
          
           _backgroundUserValue = res;   
           QString text;

           text.sprintf("Uses your background value (%.1f counts/pixel) to subtract the background", _background);
           QToolTip::add( _backgroundRadioBtn[2] , text);
  
  
       }
       _source.iMin = -3;

   
       break;
    }
    case (3):  // Interpolation (extended-source only)
        _backgroundBtn->setDisabled(true);
         _fixedBackground = false;         
	 _source.iMin = -2;
         break;

    }


    _extendedSourcePhotometryMethod = _source.iMin;

    //cout << "updatebackgrounddetermination fixedbackground=" << _fixedBackground << endl;
    //cout << "imin=" << _source.iMin << endl;


}
/************************************************************
*
***********************************************************/
void PhotometryDlg::resetSource()
{


    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
    OmSourceParameter tempSource =  mySources[_sourceNo];

    tempSource.rawbackgroundcountrate = _background;
            
    F90MODPROC(omsource_glue, replace)(_sourceNo, tempSource);
    
}
/************************************************************
*
***********************************************************/
float PhotometryDlg::signalToNoise(const float & source, const float &background, const float &exposure)
{

    float s = source * exposure;
    float b = background * exposure;

    return s / sqrt(s + 2.0 * b);


}
/****************************************************************
*
****************************************************************/
void PhotometryDlg::colour1Changed( int no )
{
    _colour1No = no;
    _colour1 = _colourList[no - 1];

    startTimer();

}

/****************************************************************
*
****************************************************************/
void PhotometryDlg::colour2Changed( int no )
{
    _colour2No = no;
 
    _colour2 = _colourList[no - 1];

    startTimer();

}












//#include <cmath>
//#include <cstdlib>
//#include <string>

//#include "common.h"
#include "CalServer.h"
//#include "Celestial.h"
//#include "Ccf.h"
//#include "Image.h"



#include "CalOalUtility.h"


//#include "errstr.h"
//#include "f90cxx.h"
//#include "Dal.h"
//#include "Handle.h"
//#include "STime.h"

//#include "BadPixelDataServer.h"
//#include "CrossPsf.h"
//#include "CcdQuantumDataServer.h"
//#include "CtiCorrector.h"
//#include "EffectiveAreaDataServer.h"
//#include "EnergyCorrector.h"
//#include "GeometryDataServer.h"
//#include "MiscDataServer.h"
//#include "OmGeoLinearizer.h"
//#include "OmGrismDataServer.h"
//#include "PsfDataServer.h"
//#include "Redistribution.h"
//#include "TimeCorrector.h"

//#include <vector>

using namespace CalOalUtility;

//using namespace std;




#include "Dal.h"
#include "param.h"
#include <iostream>

/******************************************************
*
******************************************************/
void PhotometryDlg::photometricConstants()
{

    //  create an OM engine




  //    calServer.setInstrument(Xmm::OM);

  //    if(filter == "UVW2" || filter == "uvw2")
  //        calServer.state()->filter()->set(Xmm::UVW2);
  //    else if(filter == "UVM2" || filter == "uvm2")
  //        calServer.state()->filter()->set(Xmm::UVM2);
  //    else if(filter == "UVW1" || filter == "uvw1")
  //        calServer.state()->filter()->set(Xmm::UVW1);
  //    else if(filter == "U" || filter == "u")
  //        calServer.state()->filter()->set(Xmm::U);
  //    else if(filter == "B" || filter == "b")
  //        calServer.state()->filter()->set(Xmm::B);
  //    else if(filter == "V" || filter == "v")
  //        calServer.state()->filter()->set(Xmm::V);
  //    else if(filter == "GRISM1" || filter == "GRISM1")
  //        calServer.state()->filter()->set(Xmm::GRISM1);



    OmColorTransformator *ct = 0;
    ct = calServer.getAtom( ct );


    OmColorTransformator::OmFluxConvF f = ct->fluxConversionFactors();


    //   cout << "AB Magnitude zero-point=" << f.zpab << endl;
    // cout << "AB Flux conversion factor=" << showpoint << setw(15) << f.cfab << endl;


    // cout << "VEGA Flux conversion factor=" << showpoint << setw(15) << f.cfvega << endl;
    // cout << "WHITE DWARF  Flux conversion factor=" << showpoint << setw(15) << f.cfwd << endl;


}

/******************************************************
*
******************************************************/
void PhotometryDlg::computeABMagsAndFluxes(float rate, float rateErr, 
                     float &mag, float &magErr, float &flux, float &fluxErr)
{

    if(rate <= 0.0) 
    {

      mag = 0.0;
      magErr = 0.0;
      flux = 0.0;
      fluxErr = 0.0;
      return;
    }   

    OmColorTransformator *ct = 0;
    ct = calServer.getAtom( ct );


    OmColorTransformator::OmFluxConvF f = ct->fluxConversionFactors();

    
    /*************************************************************
    * Compute the AB magnitude from the count-rate
    *
    *************************************************************/

    mag =  f.zpab - 2.5 * log10( rate );            
       
    magErr = max(0.01, 1.085735 * rateErr / rate);

    flux =  rate * f.cfab;            
    fluxErr = rateErr *  f.cfab;        
                
}

/******************************************************
*
******************************************************/
    
void PhotometryDlg::showHelpInformation()
{
 
    static const char* information[] = {
  
    "<b>RECOMPUTING THE PHOTOMETRY</b><br>"
    "<hr><br><br>"
                    "<b>1)</b> If you wish the photometry to be conducted as for a <b>point-like</b> source "
                    "<bf>(ie using a circular aperture and a circular annulus background region)</bf>"  
                    "please first make sure that the \"<b>Source type</b>\" button is set to \"<b>Point</b>\"."
                    "You can then change the aperture radius and the inner and outer background annulus radii.<br>" 
                    "Pressing the \"<b>Compute</b>\" button will cause the photometry to be recomputed. "
                    "Some of the computed parameters will be stored in the lower table.<br><br>" 

                   "<b>2)</b> If you wish the photometry to be conducted as for an <b>extended</b> source "
                    "please first make sure that the \"<b>Source type</b>\" button is set to \"<b>Extended</b>\"."
                    "You can then use an elliptical aperture to match the size and orientation of the source. "
                    "The background annulus will have the same shape as the aperture, but its size and distance "
                    "from the aperture can be changed.<br>"  
                    "Pressing the \"<b>Compute</b>\" button will cause the photometry to be recomputed. "
    "Some of the computed parameters will be stored in the lower table.<br><br><br><br>"

    "<b>BACKROUND DETERMINATION</b>- There are four different ways of subtracting the background-. <br><br>"
    "<b>1)</b> By computing a  value of the mean background-counts per pixel by using the pixels within an "
    "annulus region centred on the source.<br><br>"
    "<b>2)</b> By by using <b>user-selected</b> regions to obtain a value for the mean "
    " background-counts per pixel.<br><br>"
    "<b>3)</b> By using  a  <b>user-supplied</b> value for the mean background-counts per pixel.<br><br>"
    "<b>4)</b> <b>(EXTENDED SOURCES ONLY)</b> By using the pixels within the background annulus region "
    "to interpolate the background at a particular source pixel position.", 
    0};     
                    
 

    HelpDlg *helpDlg = new HelpDlg( this, information);


    helpDlg->exec();
         
    delete helpDlg;  
 
}
/*************************************************************
*
************************************************************/
void PhotometryDlg::mousePressEvent( QMouseEvent* event)
{
  
    if ( event->button() == RightButton )
    {   

        showHelpInformation();
    }



}




